diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
index 174fa6963..7a768d0f6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
@@ -40,8 +40,8 @@ public class ParticleLeaf extends Particle {
     @Override
     public void tick() {
         this.cachedLightmapCoord = calcLightIndex(1f);
-        float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, (float) this.x, (float) this.y, (float) this.z);
-        float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, (float) this.x, (float) this.y, (float) this.z) * 0.01f;
+        float windDirection = this.world.getWorldType().getWindManager().getWindDirection(this.world, (float) this.x, (float) this.y, (float) this.z);
+        float windIntensity = this.world.getWorldType().getWindManager().getWindIntensity(this.world, (float) this.x, (float) this.y, (float) this.z) * 0.01f;
 
         float dx = (float) (Math.cos(windDirection * Math.PI * 2) * windIntensity);
         float dz = (float) (Math.sin(windDirection * Math.PI * 2) * windIntensity);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index 5b20c4cc1..a76932b2f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldEmpty;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -33,7 +34,7 @@ public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityM
         GLRenderer.modelM4f().translate((float) x + 0.5F, (float) y, (float) z + 0.5F);
         Entity entity = this.entityHashMap.get(mobSpawner.getMobId());
         if (entity == null) {
-            entity = EntityDispatcher.getInstance().createEntityInWorld(mobSpawner.getMobId(), WorldClient.EMPTY_WORLD);
+            entity = EntityDispatcher.getInstance().createEntityInWorld(mobSpawner.getMobId(), WorldEmpty.INSTANCE);
             this.entityHashMap.put(mobSpawner.getMobId(), entity);
         }
         if (entity != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index bc7b6482a..add22177d 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,18 +1,26 @@
 package net.minecraft.client.world;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
+import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
+import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
+import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
@@ -27,9 +35,11 @@ import org.joml.Vector3f;
 import org.joml.Vector3fc;
 
 public class WorldClient extends World {
-    public static final WorldClient EMPTY_WORLD = new WorldClient();
+    private final @NotNull Minecraft mc;
+    private int lightningFlicker;
 
     public WorldClient(
+        final @NotNull Minecraft mc,
         final @NotNull LevelStorage levelStorage,
         final @Nullable String name,
         final long seed,
@@ -37,35 +47,40 @@ public class WorldClient extends World {
         final @Nullable Biome startingBiome
     ) {
         super(levelStorage, name, seed, dimension, startingBiome);
+
+        this.mc = mc;
     }
 
     public WorldClient(
-        final @NotNull World world,
+        final @NotNull WorldClient parent,
         final @NotNull Dimension dimension
     ) {
-        super(world, dimension);
+        super(parent, dimension);
+
+        this.mc = parent.mc;
     }
 
-    public WorldClient(
-        final @NotNull SavedDataStorage savedDataStorage,
-        final @NotNull String name,
-        final long seed,
-        final @NotNull Dimension dimension,
-        final @NotNull WorldType worldType
-    ) {
-        super(savedDataStorage, name, seed, dimension, worldType);
+    @Override
+    public void setLightningFlicker(final int lightningFlicker) {
+        this.lightningFlicker = lightningFlicker;
     }
 
-    public WorldClient() {
-        this.dimension = Dimension.OVERWORLD;
-        this.worldType = WorldTypes.DEBUG;
-        this.chunkProvider = new ChunkProviderViewer(this);
-        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
-        updateSkyBrightness();
+    public int getLightningFlicker() {
+        return this.lightningFlicker;
+    }
+
+    @Override
+    protected @NotNull ChunkProvider createChunkProvider(final @NotNull LevelStorage levelStorage) {
+        final ChunkLoader chunkLoader = levelStorage.getChunkLoader(this.dimension);
+        return switch (GameSettings.CHUNK_PROVIDER.value) {
+            case DYNAMIC ->
+                new ChunkProviderDynamic(this, chunkLoader, this.getWorldType().createChunkGenerator(this));
 
-        this.weatherManager = new WeatherManager(this);
+            case THREADED ->
+                new ChunkProviderThreadedClient(this, chunkLoader, this.getWorldType().createChunkGenerator(this));
 
-        this.biomeProvider = this.worldType.createBiomeProvider(this);
+            default -> new ChunkProviderStatic(this, chunkLoader, this.getWorldType().createChunkGenerator(this));
+        };
     }
 
     @Override
@@ -106,7 +121,7 @@ public class WorldClient extends World {
         double y = camera.getY(partialTick);
         double z = camera.getZ(partialTick);
         float celestialAngle = getCelestialAngle(partialTick);
-        return WorldTypeFXDispatcher.getInstance().getDispatch(this.worldType).getFogColor(this, x, y, z, celestialAngle, partialTick);
+        return WorldTypeFXDispatcher.getInstance().getDispatch(this.getWorldType()).getFogColor(this, x, y, z, celestialAngle, partialTick);
     }
 
     public @NotNull Vector3fc getSkyColor(@NotNull ICamera camera, float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 1cd0a5b1c..b3a826e02 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -2,6 +2,7 @@ package net.minecraft.client.world;
 
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
 import net.minecraft.core.block.Block;
@@ -12,11 +13,12 @@ import net.minecraft.core.net.packet.PacketDisconnect;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.save.LevelStorageDummy;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -34,16 +36,19 @@ public class WorldClientMP extends WorldClient {
 
     public WorldClientMP(
         final @NotNull PacketHandlerClient packetHandler,
+        final @NotNull Minecraft mc,
         final long seed,
         final int dimensionId,
         final int worldTypeId
     ) {
         super(
-            packetHandler.savedDataStorage,
+            mc,
+            new LevelStorageDummy(),
             "MpServer",
             seed,
             Dimension.getDimensionList().get(dimensionId),
-            Registries.WORLD_TYPES.getItemByNumericId(worldTypeId)
+//            Registries.WORLD_TYPES.getItemByNumericId(worldTypeId)
+            null
         );
 
         this.positionTypesList = new LinkedList<>();
@@ -101,7 +106,7 @@ public class WorldClientMP extends WorldClient {
     }
 
     @Override
-    protected IChunkProvider createChunkProvider() {
+    protected @NotNull ChunkProvider createChunkProvider(final @NotNull LevelStorage levelStorage) {
         this.chunkCache = new ChunkProviderClient(this);
         return this.chunkCache;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java b/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java
new file mode 100644
index 000000000..501578fda
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java
@@ -0,0 +1,22 @@
+package net.minecraft.client.world;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
+import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.save.LevelStorageDummy;
+import org.jetbrains.annotations.NotNull;
+
+public class WorldEmpty extends WorldClient {
+    public static final @NotNull WorldEmpty INSTANCE = new WorldEmpty(Minecraft.getMinecraft());
+
+    private WorldEmpty(final @NotNull Minecraft mc) {
+        super(mc, new LevelStorageDummy(), "Empty World", 0, Dimension.OVERWORLD, null);
+    }
+
+    @Override
+    protected @NotNull ChunkProvider createChunkProvider(final @NotNull LevelStorage levelStorage) {
+        return new ChunkProviderViewer(this);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index cb86c1179..f18cc4cca 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -5,14 +5,15 @@ import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.EmptyChunk;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
-public class ChunkProviderClient implements IChunkProvider {
+public class ChunkProviderClient implements ChunkProvider {
     protected static final @NotNull ChunkPos MIN_POS = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
 
     private final @NotNull Chunk blankChunk;
@@ -30,7 +31,7 @@ public class ChunkProviderClient implements IChunkProvider {
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         if (chunkPos.equals(this.lastQueriedChunkPos)) return true;
         if (this.chunkMapping.containsKey(chunkPos)) {
             this.lastQueriedChunkPos = new ChunkPos(chunkPos);
@@ -41,7 +42,7 @@ public class ChunkProviderClient implements IChunkProvider {
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
     }
 
     public void dropChunk(@NotNull ChunkPos chunkPos) {
@@ -53,7 +54,7 @@ public class ChunkProviderClient implements IChunkProvider {
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         if (this.chunkMapping.containsKey(chunkPos)) return this.chunkMapping.get(chunkPos);
         Chunk chunk = new Chunk(this.world, new ChunkPos(chunkPos));
         this.chunkMapping.put(chunk.pos, chunk);
@@ -62,11 +63,11 @@ public class ChunkProviderClient implements IChunkProvider {
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         if (chunkPos.equals(this.lastQueriedChunkPos)) return this.lastQueriedChunk;
         Chunk chunk = this.chunkMapping.get(chunkPos);
         if (chunk != null) {
-            this.lastQueriedChunkPos = chunkPos;
+            this.lastQueriedChunkPos.set(chunkPos);
             this.lastQueriedChunk = chunk;
             return chunk;
         }
@@ -93,7 +94,7 @@ public class ChunkProviderClient implements IChunkProvider {
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
     }
 
     @Override
@@ -102,7 +103,7 @@ public class ChunkProviderClient implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
         // Do nothing
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
index fb07bd306..4b651703c 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
@@ -4,9 +4,10 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.*;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -14,13 +15,13 @@ import org.slf4j.Logger;
 import java.io.IOException;
 import java.util.*;
 
-public class ChunkProviderDynamic implements IChunkProvider {
+public class ChunkProviderDynamic implements ChunkProvider {
     public static final int CHUNK_RADIUS = 32;
     private static final Logger LOGGER = LogUtils.getLogger();
     private final Set<ChunkPos> droppedChunksSet;
     private final Chunk emptyChunk;
     public @Nullable ChunkGenerator chunkGenerator;
-    private final @Nullable IChunkLoader chunkLoader;
+    private final @Nullable ChunkLoader chunkLoader;
     private final @NotNull Map<@NotNull ChunkPos, @NotNull Chunk> chunkMap;
     private final @NotNull Map<@NotNull ChunkPos, @NotNull Chunk> forceLoadedChunkMap;
     private final @NotNull List<Chunk> forceLoadedChunkList;
@@ -33,7 +34,7 @@ public class ChunkProviderDynamic implements IChunkProvider {
     private int lastQueriedChunkZPos;
     private Chunk lastQueriedChunk;
 
-    public ChunkProviderDynamic(@NotNull World world, @Nullable IChunkLoader chunkLoader, @Nullable ChunkGenerator chunkGenerator) {
+    public ChunkProviderDynamic(@NotNull World world, @Nullable ChunkLoader chunkLoader, @Nullable ChunkGenerator chunkGenerator) {
         this.droppedChunksSet = new HashSet<>();
         this.chunkMap = new HashMap<>();
         this.forceLoadedChunkList = new ArrayList<>();
@@ -45,40 +46,40 @@ public class ChunkProviderDynamic implements IChunkProvider {
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
 
         if (canChunkBeUnloaded(chunkPos)) {
-            if (this.chunkMap.containsKey(chunkPos)) this.droppedChunksSet.add(chunkPos);
+            if (this.chunkMap.containsKey(chunkPos)) this.droppedChunksSet.add(new ChunkPos(chunkPos));
             return false;
         }
         Chunk chunk = this.chunkMap.get(chunkPos);
         return chunk == this.emptyChunk || (chunk != null && chunk.isAtLocation(chunkPos));
     }
 
-    public boolean canChunkBeUnloaded(@NotNull ChunkPos chunkPos) {
+    public boolean canChunkBeUnloaded(@NotNull ChunkPosc chunkPos) {
 
         if (this.forceLoadedChunkMap.containsKey(chunkPos)) return false;
         int renderDistance = CHUNK_RADIUS - 1;
-        return !(chunkPos.x >= this.currentChunkX - renderDistance && chunkPos.z >= this.currentChunkZ - renderDistance && chunkPos.x <= this.currentChunkX + renderDistance && chunkPos.z <= this.currentChunkZ + renderDistance);
+        return !(chunkPos.x() >= this.currentChunkX - renderDistance && chunkPos.z() >= this.currentChunkZ - renderDistance && chunkPos.x() <= this.currentChunkX + renderDistance && chunkPos.z() <= this.currentChunkZ + renderDistance);
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
-        if (chunkPos.x == this.lastQueriedChunkXPos && chunkPos.z == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        if (chunkPos.x() == this.lastQueriedChunkXPos && chunkPos.z() == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
             return this.lastQueriedChunk;
         }
         if (!this.world.findingSpawnPoint && canChunkBeUnloaded(chunkPos)) return this.emptyChunk;
 
-        if (!isChunkLoaded(chunkPos.x, chunkPos.z)) {
+        if (!isChunkLoaded(chunkPos.x(), chunkPos.z())) {
             if (this.chunkMap.get(chunkPos) != null) {
                 Chunk chunk = this.chunkMap.get(chunkPos);
                 saveChunk(chunk);
                 chunk.onUnload();
             }
-            Chunk chunk = loadChunk(chunkPos.x, chunkPos.z);
+            Chunk chunk = loadChunk(chunkPos.x(), chunkPos.z());
             if (chunk == null) {
                 if (this.chunkGenerator != null) {
-                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+                    chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
                     chunk.fixMissingBlocks();
                 } else {
                     chunk = this.emptyChunk;
@@ -87,60 +88,96 @@ public class ChunkProviderDynamic implements IChunkProvider {
             this.chunkMap.put(new ChunkPos(chunkPos), chunk);
             chunk.checkForLightGaps();
             chunk.onLoad();
-            if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-                populate(this, chunkPos.x, chunkPos.z);
+            final @NotNull ChunkPos queryPos = new ChunkPos(chunkPos);
+            if (
+                !chunk.isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+            ) {
+                populate(chunkPos);
             }
-            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-                populate(this, chunkPos.x - 1, chunkPos.z);
+            if (
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos)) && !provideChunk(chunkPos.add(-1, 0, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(-1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos))
+            ) {
+                populate(chunkPos.add(-1, 0, queryPos));
             }
-            if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-                populate(this, chunkPos.x, chunkPos.z - 1);
+            if (
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) && !provideChunk(chunkPos.add(0, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+            ) {
+                populate(chunkPos.add(0, -1, queryPos));
             }
-            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-                populate(this, chunkPos.x - 1, chunkPos.z - 1);
+            if (
+                isChunkLoaded(chunkPos.add(-1, -1, queryPos)) && !provideChunk(chunkPos.add(-1, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos))
+            ) {
+                populate(chunkPos.add(-1, -1, queryPos));
             }
             if (this.world.getCurrentWeather() != null) {
                 this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
             }
         }
-        this.lastQueriedChunkXPos = chunkPos.x;
-        this.lastQueriedChunkZPos = chunkPos.z;
+        this.lastQueriedChunkXPos = chunkPos.x();
+        this.lastQueriedChunkZPos = chunkPos.z();
         this.lastQueriedChunk = this.chunkMap.get(chunkPos);
         return this.chunkMap.get(chunkPos);
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         return provideChunk(chunkPos, true);
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
 
         this.droppedChunksSet.remove(chunkPos);
         this.chunkMap.remove(chunkPos);
         Chunk chunk;
         if (this.chunkGenerator != null) {
-            chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+            chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
             chunk.fixMissingBlocks();
         } else return;
         this.chunkMap.put(new ChunkPos(chunkPos), chunk);
-        if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x, chunkPos.z));
+        final @NotNull ChunkPos queryPos = new ChunkPos(chunkPos);
+        if (
+            !chunk.isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+        ) {
+            populate(chunkPos);
         }
-        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z));
+        if (
+            isChunkLoaded(chunkPos.add(-1, 0, queryPos)) && !provideChunk(chunkPos.add(-1, 0, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(-1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos))
+        ) {
+            populate(chunkPos.add(-1, 0, queryPos));
         }
-        if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x, chunkPos.z - 1));
+        if (
+            isChunkLoaded(chunkPos.add(0, -1, queryPos)) && !provideChunk(chunkPos.add(0, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+        ) {
+            populate(chunkPos.add(0, -1, queryPos));
         }
-        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z - 1));
+        if (
+            isChunkLoaded(chunkPos.add(-1, -1, queryPos)) && !provideChunk(chunkPos.add(-1, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos))
+        ) {
+            populate(chunkPos.add(-1, -1, queryPos));
         }
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
         Chunk chunk = provideChunk(chunkPos, true);
         if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
@@ -245,7 +282,7 @@ public class ChunkProviderDynamic implements IChunkProvider {
         return true;
     }
 
-    public @Nullable IChunkLoader getChunkLoader() {
+    public @Nullable ChunkLoader getChunkLoader() {
         return this.chunkLoader;
     }
 
@@ -272,8 +309,8 @@ public class ChunkProviderDynamic implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
-        this.currentChunkX = chunkPos.x;
-        this.currentChunkZ = chunkPos.z;
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
+        this.currentChunkX = chunkPos.x();
+        this.currentChunkZ = chunkPos.z();
     }
 }
\ No newline at end of file
